/* Convenience object for listening to when host is selected/unselected */

var SelectionListener = function(onChange) {
	this._isSelected = false;
	this.onChange = onChange;

	//Initialize _isSelected
	var guid = NB.getHostObject().guid;
	var objs = NB.page.getSelectedObjects();
	for(var i = 0; i < objs.length; i++) {
		if(objs[i].guid === guid) {
			this._isSelected = true;
		}
	}

	//Add Listens
	NB.addObserver('annotationSelectionAddedEvent', this.annotationSelectionAddedEvent.bind(this));
	NB.addObserver('annotationDeSelectedEvent', this.annotationDeSelectedEvent.bind(this));
};

SelectionListener.prototype = {

	isSelected: function() {
		return this._isSelected;
	},

	annotationSelectionAddedEvent: function(event) {
		if(this.nbEventHasMe(event)) {
			this._isSelected = true;
			this.onChange(this, true);
		}
	},

	annotationDeSelectedEvent: function(event) {
		if(this.nbEventHasMe(event)) {
			this._isSelected = false;
			this.onChange(this, false);
		}
	},

	nbEventHasMe: function(event) {
		var guids = event.eventData.annIds;
		var guid = NB.getHostObject().guid;
		return guids.indexOf(guid) !== -1;
	},

};

