var SpinAnim = function(spinnerView, onEnd) {
	this.view = spinnerView;
	this.duration = 2000;
	this.startRadians = 0;
	this.finalRadians = 0;
	this.onEnd = onEnd;
	this.randomize();
	this.start();
};

SpinAnim.prototype = {

	start: function() {
		var d = this.finalRadians * 180 / Math.PI;
		$('#pointerLine').velocity({
			rotateZ: [
				this.finalRadians * 180 / Math.PI,
				this.startRadians * 180 / Math.PI,
			],
		}, {
			duration: this.duration,
			complete: this._complete.bind(this),
			easing: 'easeOutQuad',
		});
		
	},

	randomize: function() {
		// Make cursor go to a position that is not close to a wedge border
		this.startRadians = this.view.pointerRadians();
		var radsDif = (2 + 2 * Math.random()) * 2 * Math.PI;
		var rads2 = this.startRadians + radsDif;
		var segment = 2 * Math.PI / this.view.count();
		var fromFir = rads2 - this.view.firstAngle();
		// Distance to closest border, as a percentage of the segment length.
		var closeness = (Math.abs(rads2 - this.view.firstAngle()) % segment) / segment;
		if(closeness > 0.5) {
			closeness = 1 - closeness;
		}
		if(closeness < 0.1) {
			rads2 += segment / 2;
		}
		this.finalRadians = rads2;
	},

	stop: function() {
		$('#pointerLine').velocity('stop');
	},

	_complete: function() {
		this.view.setPointerRadians(this.finalRadians);
		if(this.onEnd) {
			this.onEnd(this);
		}
	},

};
